/* ELITEBUG.C - This program accepts start and finish pairs of 
co-ordinates from the Frontier star chart and calculates the intermidiate
co-ordinates to take advantage of the 81.92 sector bug */

/* Include librarys */

#include <stdio.h>
#include <math.h>

/* Prototype functions */

void print_blurb(void);
void get_start_coor(void);
void get_finish_coor(void);
void calc_inter(double x_start, double y_start, double x_finish, double y_finish);
void show_results(void);

/* declare variables */

double x_start, y_start, x_finish, y_finish ;
double x_intermediate, y_intermediate ;

/* main function */

main(void)
{
	char answer[80];

	/* Print out blurb */
	print_blurb();

	do
	{
		/* Get start co-ordinates */
		get_start_coor();

		/* Get finish co-ordinates */
		get_finish_coor();
	
		/* Calculate intermediate co-ordinates */
		calc_inter( x_start, y_start, x_finish, y_finish);
	
		/* Display results */
		show_results();
	
		/* Run again? */
	
		printf("Run again (y/N)?");
		flushall();
		gets(answer);

	}
	while (answer[0] == 89 || answer[0] == 121);
	
	return 1;
}


/* Funtion to print out blurb */
	
void print_blurb(void)
{
	printf("The Frontier worm hole calculator V1.00\n");
	printf("---------------------------------------\n\n");
	printf("Written by Karl Foley @ 2:2501/101 15/1/94\n");
	printf("------------------------------------------");
}

/* Get start x and y co-ordinates */

void get_start_coor(void)
{
	printf("\n\nPlease enter your start X & Y co-ordinates from the Frontier starmap\n");
	printf("in the form x,y :");
	scanf("%lf,%lf", &x_start, &y_start);
}


/* Get finish x and y co-ordinates */

void get_finish_coor(void)
{
	printf("\n\nPlease enter your finish X & Y co-ordinates from the Frontier starmap\n");
	printf("in the form x,y :");
	scanf("%lf,%lf", &x_finish, &y_finish);
}


/* Calculate intermediate co-ordinates */

void calc_inter(double x_start, double y_start, double x_finish, double y_finish)
{
	
	/* Declare local variables */
	
	double start_end_distance, half_way_to_inter, x_origin, y_origin, angle;
	double half_pi = 1.570796327;
	double bug_constant = 81.92;

	/* Calculate start point to finish point distance */

	start_end_distance = sqrt( pow( ( x_finish - x_start) ,2.0 ) + 
							   pow( ( y_start - y_finish) ,2.0 )) ;

	/* Calculate distance between a point half way between x & y start 
       and x & y finish, and intermediate x & y points (length of spoke) */

	half_way_to_inter = sqrt( pow( bug_constant ,2.0 ) -
							  pow(( start_end_distance / 2 ) ,2.0 ));

	/* Calculate origin point of spoke */

	y_origin = (( y_start - y_finish) / 2 ) + y_finish ;
	x_origin = (( x_finish - x_start) / 2 ) + x_start ;

	/* Calculate angle of spoke if x_start doesn't equal x_finish,
	   if it does then set angle to equal arctan(infinity)        */
		
	if ( y_start == y_finish)
		angle = half_pi;
	else
		angle = atan( ( x_finish - x_start ) / ( y_start - y_finish )  );

	/* Calculate x & y intermediate co-ordinates */

	y_intermediate = y_origin + ( half_way_to_inter * sin( angle) );
	x_intermediate = x_origin + ( half_way_to_inter * cos( angle) );

}


/* Display results */

void show_results(void)
{
	printf("\n\nThe intermediate jump point from [%.1lf,%.1lf] to \n", x_start, y_start);
	printf("finish point [%.1lf,%.1lf] is [%.1lf,%.1lf].\n\n", x_finish, y_finish, x_intermediate, y_intermediate);
}
